package Business::BankList::Indonesia;

use 5.010;
use strict;
use warnings;
use Perinci::Sub::Gen::AccessTable qw(gen_read_table_func);

use Exporter;
our @ISA = qw(Exporter);
our @EXPORT_OK = qw(
                       list_id_banks
               );

our %SPEC;

our $VERSION = '0.01'; # VERSION

# BEGIN SNIPPET id=data
# note: This section is generated by a script. Do not edit manually!
# src-file: /mnt/home/s1/repos/gudang-data-interim/data/idn_bank/data.csv
# src-revision: 69c97b86306d914d13d272d4d157b6886d566510
# revision-date: Fri Jul 6 18:52:39 2012 +0700
# generate-date: Fri Jul  6 19:00:08 2012
# generated-by: /mnt/home/s1/repos/gudang-data-interim/bin/gen-perl-data-snippet
our $data = [
    ['1','BANK INDONESIA','bi',''],
    ['3','BANK OF AMERICA, NA','','033'],
    ['4','BANK OF CHINA LIMITED','','069'],
    ['5','BANK RAKYAT INDONESIA SYARIAH TBK.','bri_syariah',''],
    ['6','CAPITAL','',''],
    ['7','CITIBANK, NA','citibank','031'],
    ['8','CREDIT LYONNAIS','',''],
    ['9','DEUTSCHE BANK AG','','067'],
    ['10','JPMORGAN CHASE BANK, NA','','032'],
    ['11','PT. BANK BNI SYARIAH','bni_syariah',''],
    ['12','PT. BANK DANAMON SYARIAH','danamon_syariah',''],
    ['13','PT. BANK JABAR BANTEN SYARIAH','bjb_syariah','110'],
    ['14','PT. BANK PEMBANGUNAN DAERAH JABAR','bpd_jabar',''],
    ['15','PT. BANK PUNDI INDONESIA TBK.','pundi',''],
    ['16','PT. BII SYARIAH','bii_syariah',''],
    ['17','PT. AGRONIAGA BANK','','494'],
    ['18','PT. ANGLOMAS INTERNATIONAL BANK','','531'],
    ['19','PT. ANZ PANIN BANK','','061'],
    ['20','PT. BANK AGRIS','',''],
    ['21','PT. BANK AKITA','','525'],
    ['22','PT. BANK ANDARA','',''],
    ['23','PT. BANK ANTAR DAERAH','','088'],
    ['24','PT. BANK ARTHA GRAHA INTERNASIONAL','','037'],
    ['25','PT. BANK ARTOS INDONESIA','artos','542'],
    ['26','PT. BANK BCA SYARIAH','bca_syariah',''],
    ['27','PT. BANK BISNIS INTERNATIONAL','bisnis','459'],
    ['28','PT. BANK BNP PARIBAS INDONESIA','bnpparibas','057'],
    ['29','PT. BANK BUMI ARTA','bumiarta','076'],
    ['30','PT. BANK BUMIPUTERA','bumiputera','485'],
    ['31','PT. BANK CHINATRUST INDONESIA','chinatrust','949'],
    ['32','PT. BANK CIMB NIAGA TBK.','cimbniaga','022'],
    ['33','PT. BANK COMMONWEALTH','commonwealth','950'],
    ['34','PT. BANK DANAMON INDONESIA TBK.','danamon','011'],
    ['35','PT. BANK DBS INDONESIA','dbs','046'],
    ['36','PT. BANK DIPO INTERNATIONAL','dipo','523'],
    ['37','PT. BANK EKONOMI RAHARJA','ekonomi','087'],
    ['38','PT. BANK FAMA INTERNATIONAL','fama','562'],
    ['39','PT. BANK GANESHA','ganesha','161'],
    ['40','PT. BANK HANA','hana',''],
    ['41','PT. BANK HARDA INTERNASIONAL','harda','567'],
    ['42','PT. BANK HARFA','harfa','517'],
    ['43','PT. BANK HS 1906','hs','212'],
    ['44','PT. BANK ICBC INDONESIA','icbc',''],
    ['45','PT. BANK INA PERDANA','','513'],
    ['46','PT. BANK INDEX SELINDO','','555'],
    ['47','PT. BANK INTERNASIONAL INDONESIA','bii','016'],
    ['48','PT. BANK JASA ARTA','jasaarta','422'],
    ['49','PT. BANK JASA JAKARTA','jasajakarta','427'],
    ['50','PT. BANK KESAWAN','kesawan','167'],
    ['51','PT. BANK KESEJAHTERAAN EKONOMI','','535'],
    ['52','PT. BANK LIMAN INTERNATIONAL','liman','526'],
    ['53','PT. BANK MANDIRI TBK.','mandiri','008'],
    ['54','PT. BANK MASPION INDONESIA','maspion','157'],
    ['55','PT. BANK MAYAPADA TBK.','mayapada','097'],
    ['56','PT. BANK MAYBANK INDOCORP','maybank','947'],
    ['57','PT. BANK MAYORA INDONESIA','mayora','553'],
    ['58','PT. BANK MEGA TBK.','mega','426'],
    ['59','PT. BANK MESTIKA DHARMA','','151'],
    ['60','PT. BANK METRO EKSPRESS','','152'],
    ['61','PT. BANK MITRANIAGA','','491'],
    ['62','PT. BANK MIZUHO INDONESIA','','048'],
    ['63','PT. BANK MUAMALAT INDONESIA','muamalat','147'],
    ['64','PT. BANK MULTIARTA SENTOSA','','548'],
    ['65','PT. BANK MUTIARA TBK.','mutiara',''],
    ['66','PT. BANK NATIONALNOBU','nobu',''],
    ['67','PT. BANK NEGARA INDONESIA 46 TBK.','bni','009'],
    ['68','PT. BANK NIAGA SYARIAH TBK.','niaga_syariah',''],
    ['69','PT. BANK NUSANTARA PARAHYANGAN','bnp','145'],
    ['70','PT. BANK OCBC NISP TBK','ocbcnisp','028'],
    ['71','PT. BANK PEMBANGUNAN DAERAH BALI','bpd_bali','129'],
    ['72','PT. BANK PEMBANGUNAN DAERAH DIY','bpd_diy','112'],
    ['73','PT. BANK PEMBANGUNAN DAERAH JAMBI','bpd_jambi','115'],
    ['74','PT. BANK PEMBANGUNAN DAERAH JATENG','bpd_jateng','113'],
    ['75','PT. BANK PEMBANGUNAN DAERAH JATIM','bpd_jatim','114'],
    ['76','PT. BANK PEMBANGUNAN DAERAH KALBAR','bpd_kalbar','123'],
    ['77','PT. BANK PEMBANGUNAN DAERAH KALSEL','bpd_kalsel','122'],
    ['78','PT. BANK PEMBANGUNAN DAERAH KALTENG','bpd_kalteng','125'],
    ['79','PT. BANK PEMBANGUNAN DAERAH KALTIM','bpd_kaltim','124'],
    ['80','PT. BANK PEMBANGUNAN DAERAH LAMPUNG','bpd_lampung','121'],
    ['81','PT. BANK PEMBANGUNAN DAERAH MALUKU','bpd_maluku','131'],
    ['82','PT. BANK PEMBANGUNAN DAERAH NTB','bpd_ntb','128'],
    ['83','PT. BANK PEMBANGUNAN DAERAH NTT','bpd_ntt','130'],
    ['84','PT. BANK PEMBANGUNAN DAERAH PAPUA','bpd_papua','132'],
    ['85','PT. BANK PEMBANGUNAN DAERAH RIAU','bpd_riau','119'],
    ['86','PT. BANK PEMBANGUNAN DAERAH SULSEL','bpd_sulsel','126'],
    ['87','PT. BANK PEMBANGUNAN DAERAH SUMBAR','bpd_sumbar',''],
    ['88','PT. BANK PEMBANGUNAN DAERAH SUMSEL','bpd_sumsel','120'],
    ['89','PT. BANK PEMBANGUNAN DAERAH SUMUT','bpd_sumut','117'],
    ['90','PT. BANK PEMBANGUNAN DI ACEH','bpd_aceh','116'],
    ['91','PT. BANK PEMBANGUNAN SULUT','bpd_sulut','127'],
    ['92','PT. BANK PERMATA SYARIAH TBK.','permata_syariah',''],
    ['93','PT. BANK PERMATA TBK.','permata','013'],
    ['94','PT. BANK PERSYARIKATAN INDONESIA','','521'],
    ['95','PT. BANK RABOBANK INTERNATIONAL INDONESIA','rabo','060'],
    ['96','PT. BANK RAKYAT INDONESIA TBK.','bri','002'],
    ['97','PT. BANK RESONA PERDANIA','','047'],
    ['98','PT. BANK ROYAL INDONESIA','','501'],
    ['99','PT. BANK SAHABAT PURBA DANARTA','','547'],
    ['100','PT. BANK SBI INDONESIA','',''],
    ['101','PT. BANK SINAR HARAPAN BALI','','564'],
    ['102','PT. BANK SINAR MAS','sinarmas',''],
    ['103','PT. BANK SUMITOMO MITSUI INDONESIA','','045'],
    ['104','PT. BANK SWADESI TBK.','swadesi','146'],
    ['105','PT. BANK SWAGUNA','swaguna','405'],
    ['106','PT. BANK SYARIAH MANDIRI TBK.','mandiri_syariah','451'],
    ['107','PT. BANK SYARIAH MEGA INDONESIA','mega_syariah','506'],
    ['108','PT. BANK TABUNGAN','btpn','213'],
    ['109','PT. BANK TABUNGAN NEGARA','btn','200'],
    ['110','PT. BANK TABUNGAN NEGARA SYARIAH','btn_syariah',''],
    ['111','PT. BANK TABUNGAN SYARIAH','btpn_syariah',''],
    ['112','PT. BANK UOB BUANA TBK.','uobbuana',''],
    ['113','PT. BANK VICTORIA INTERNATIONAL','victoria','566'],
    ['114','PT. BANK WINDU KENTJANA INTL TBK.','',''],
    ['115','PT. BANK WOORI INDONESIA','','068'],
    ['116','PT. BANK YUDHA BHAKTI','','490'],
    ['117','PT. BPD BENGKULU','bpd_bengkulu','133'],
    ['118','PT. BPD DKI JAKARTA','bpd_dki','111'],
    ['119','PT. BPD DKI SYARIAH','bpd_dki_syariah',''],
    ['120','PT. BPD SULAWESI TENGGARA','bpd_sultra','135'],
    ['121','PT. BPD SUMBAR SYARIAH','bpd_sumbar_syariah',''],
    ['122','PT. BPD SUMSEL SYARIAH','bpd_sumsel_syariah',''],
    ['123','PT. BUKOPIN','bukopin','441'],
    ['124','PT. BANK CENTRAL ASIA TBK.','bca','014'],
    ['125','PT. BANK CAPITAL INDONESIA TBK.','','054'],
    ['126','PT. BANK SYARIAH BUKOPIN','bukopin_syariah',''],
    ['127','PT. CENTRATAMA NASIONAL BANK','','559'],
    ['128','PT. KOREA EXCHANGE BANK DANAMON','','059'],
    ['129','PT. PANIN BANK TBK.','panin','019'],
    ['130','PT. PRIMA MASTER BANK','','520'],
    ['132','STANDARD CHARTERED BANK','stanchart','050'],
    ['133','THE BANGKOK BANK PCL','','040'],
    ['134','THE BANK OF TOKYO MITSUBISHI LTD.','','042'],
    ['135','THE HONGKONG AND SHANGHAI BC','hsbc','041'],
    ['136','THE ROYAL BANK OF SCOTLAND NV','rbs',''],
    ['3001','PT. BANK PERKREDITAN RAKYAT KARYAJATNIKA SADAYA','bpr_ks',''],
    ['1001','ABN AMRO BANK NV','abnamro','052'],
]
;
# END SNIPPET id=data
# BEGIN SNIPPET id=meta
# note: This section is generated by a script. Do not edit manually!
# src-file: /mnt/home/s1/repos/gudang-data-interim/data/idn_bank/meta.yaml
# src-revision: 69c97b86306d914d13d272d4d157b6886d566510
# revision-date: Fri Jul 6 18:52:39 2012 +0700
# generate-date: Fri Jul  6 19:00:08 2012
# generated-by: /mnt/home/s1/repos/gudang-data-interim/bin/gen-perl-meta-snippet
our $meta = {
  "fields" => {
    atmb_code => {
      "index" => 3,
      "schema" => ["str*", { match => "^\\d{3}\$" }],
      "sortable" => 1,
      "summary" => "3-digit ATM Bersama code",
      "summary.alt.lang.id_ID" => "Kode ATM Bersama",
      "unique" => "",
    },
    id => {
      "description.alt.lang.id_ID" => "Dibuat oleh proyek ini, tidak mengikuti otoritas manapun, pakai hati-hati.",
      "index" => 0,
      "schema" => "int*",
      "sortable" => 1,
      "summary" => "ID",
      "summary.alt.lang.id_ID" => "Kode angka",
      "unique" => 1,
    },
    name => {
      "description.alt.lang.id_ID" => "Umumnya berupa nama perusahaan.",
      "index" => 1,
      "schema" => "str*",
      "sortable" => 1,
      "summary" => "Name",
      "summary.alt.lang.id_ID" => "Nama",
      "unique" => 1,
    },
    nickname => {
      "index" => 2,
      "schema" => "str",
      "sortable" => 1,
      "summary" => "Short name",
      "summary.alt.lang.id_ID" => "Nama pendek",
      "unique" => 1,
    },
  },
  "pk" => "id",
  "summary" => "Indonesian banks/financial institutions",
  "summary.alt.lang.id_ID" => "Bank/institusi finansial di Indonesia",
  "table_aliases.alt.lang.id_ID" => ["bank_idn"],
}
;
# END SNIPPET id=meta
my $res = gen_read_table_func(
    table_data => $data,
    table_spec => $meta,
    default_fields => 'name',
);

die "BUG: Can't generate func: $res->[0] - $res->[1]"
    unless $res->[0] == 200;

my $spec = $res->[2]{meta};
$SPEC{list_id_banks} = $spec;
no warnings;
*list_id_banks = $res->[2]{code};
use warnings;

1;
# ABSTRACT: Utilities for dealing with bank card number (ISO/IEC 7812)


__END__
=pod

=head1 NAME

Business::BankList::Indonesia - Utilities for dealing with bank card number (ISO/IEC 7812)

=head1 VERSION

version 0.01

=head1 SYNOPSIS

=head1 DESCRIPTION

B<NOTE: This module is still empty without implementation. Plans are to provide
a list of IIN codes, routines to parse a card number into components, routines
to validate card number, etc.>

About bank card number: Bank card numbers are found on payment cards, such as
credit cards and debit cards. They have a certain amount of internal structure
and shares a common numbering scheme. Bank card numbers are allocated in
accordance with ISO/IEC 7812. An ISO/IEC 7812 number is typically 16 digits in
length. It consists of: 1) a six-digit Issuer Identification Number (IIN), the
first digit of which is the Major Industry Identifier (MII); 2) a variable
length (up to 12 digits) individual account identifier; 3) a single check digit
calculated using the Luhn algorithm.

The term "Issuer Identification Number" (IIN) replaces the previously used "Bank
Identification Number" (BIN). See ISO/IEC 7812 for more information.

=head1 SEE ALSO

L<Business::BankCard::Indonesia>

L<Business::CardInfo>

=head1 AUTHOR

Steven Haryanto <stevenharyanto@gmail.com>

=head1 COPYRIGHT AND LICENSE

This software is copyright (c) 2012 by Steven Haryanto.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

=cut

